<?php

/*
 	$Id: AdumoOnline.php,v 1 2007/04/26 $
 	Steven Ellis, AdumoOnline
  	Copyright (c) 2007 AdumoOnline
	Released under the GNU General Public License

	THIS PAGE IS USED TO PROCESS ONLINE PAYMENTS THROUGH THE
	AdumoOnline PAYMENT GATEWAY.

	PLEASE NOTE THE FOLLOWING:
	-	The Merchant reference is composed of the CustomerID concatenated with a 'dash' (-) and the date and time of the transaction
	-	The Session information MUST be passed to the AdumoOnline payment URL in the 'Variable1' form variable, as this is posted back to the Zencart application to allow the transaction to continue

	MUST BE INSERTED INTO		'//includes/modules/payment/'	FOLDER

  AdumoOnline   adumoonline ADUMOONLINE
  https://staging-apiv2.wirecard.co.za/product/payment/v1/initialisevirtual
  https://apiv2.wirecard.co.za/product/payment/v1/initialisevirtual

*/

  require 'AdumoOnline/vendor/autoload.php';

  use Lcobucci\JWT\Signer\Key;
  use Lcobucci\JWT\Signer\Hmac\Sha256 as Signer;
  use Lcobucci\JWT\Parser;
  use Lcobucci\JWT\Builder as Builder;

  class adumoonline extends base {
  var $code, $title, $description, $enabled;

// class constructor
    function __construct($paypal_ipn_id = '') {
      global $order;

      $this->code = 'AdumoOnline';
      $this->title = MODULE_PAYMENT_ADUMOONLINE_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_ADUMOONLINE_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_ADUMOONLINE_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_ADUMOONLINE_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_ADUMOONLINE_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_ADUMOONLINE_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

     //$this->form_action_url = 'https://staging-apiv2.wirecard.co.za/product/payment/v1/initialisevirtual';

       // Set posting destination destination
       if( MODULE_PAYMENT_ADUMOONLINE_SERVER == 'Test' )
           $this->form_action_url = 'https://staging-apiv2.wirecard.co.za/product/payment/v1/initialisevirtual';
       else
           $this->form_action_url = 'https://apiv2.wirecard.co.za/product/payment/v1/initialisevirtual';

    }

    function update_status() {
      global $order, $db;

      if ($this->enabled && (int)MODULE_PAYMENT_ADUMOONLINE_ZONE > 0 && isset($order->billing['country']['id'])) {
        $check_flag = false;
        $check_query = $db->Execute("SELECT zone_id FROM " . TABLE_ZONES_TO_GEO_ZONES . " WHERE geo_zone_id = '" . MODULE_PAYMENT_ADUMOONLINE_ZONE . "' AND zone_country_id = '" . (int)$order->billing['country']['id'] . "' ORDER BY zone_id");
        while (!$check_query->EOF) {
          if ($check_query->fields['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check_query->fields['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
          $check_query->MoveNext();
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }

	}

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
       //global $HTTP_POST_VARS, $shipping_cost, $shipping_selected, $shipping_method, $customer_id , $order;
       global $db, $order, $currencies, $currency;

       //$_SESSION['order'] = $order;

       //// Set the currency and get the order amount
       $currency = 'ZAR';
       //$session_name = '';
       $currencyDecPlaces = $currencies->get_decimal_places( $currency );
       $this->totalsum = $order->info['total'];
       $this->transaction_currency = $currency;
       $this->transaction_amount = ( $this->totalsum * $currencies->get_value( $currency ) );
       $this->transaction_amount = number_format( $this->transaction_amount, 2, '.', '' );

       //Build the JWT request tokens$signer = new Signer();
       $MerchantID = MODULE_PAYMENT_ADUMOONLINE_MERCHANT_ID;
       $ApplicationID = MODULE_PAYMENT_ADUMOONLINE_APPLICATION_ID;
       //$amount = $this->transaction_amount;
       $merchantReference = "REF - " . date("ymdHi");
       $SecretKey = MODULE_PAYMENT_ADUMOONLINE_JWT_SECRET_KEY;
       $iss = 'Zencart Plugin';

       $signer = new Signer();
       $authToken = (new Builder())
       ->set('iss',$iss)
       ->set('cuid',$MerchantID)
       ->set('auid',$ApplicationID)
       ->set('amount',$this->transaction_amount)
       ->set('mref',$merchantReference)
       ->setId(base64_encode(random_bytes (32)))
       ->setIssuedAt(time())
       ->setExpiration(time() + 600) // maximum: 600s
       ->sign($signer,$SecretKey)
       ->getToken();
       $authToken->getHeaders();
       $authToken->getClaims();

   // The process_button_string contains the form data that is sent to AdumoOnline.
      $process_button_string = zen_draw_hidden_field('Mode', '1') .
	  							             zen_draw_hidden_field('MerchantID', $MerchantID) .
              								 zen_draw_hidden_field('ApplicationID', $ApplicationID) .
              								 zen_draw_hidden_field('MerchantReference', $merchantReference).
              								 zen_draw_hidden_field('Amount', $this->transaction_amount).
                               zen_draw_hidden_field('Token', $authToken).
              								 zen_draw_hidden_field('txtCurrencyCode', $currency) .
                               zen_draw_hidden_field('RedirectSuccessfulURL', zen_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL', true, false)).
                               //zen_draw_hidden_field('Variable1', zen_session_name() .'='. zen_session_id()).
                               zen_draw_hidden_field('RedirectFailedURL', zen_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL', true, false));

                               return $process_button_string;
    }

    function before_process()
	  {
      // Variable initialization
      global $order_total_modules,$messageStack;

      //error_log("Post Back Data-----------------------------------".print_r($_POST,1));
      //error_log("Amount-----------------------------------".print_r($this->transaction_amount,1));

      $_SESSION["payment_data"] = $_POST;

      //Check if JWT token is in the postback
      if(isset($_POST['_RESPONSE_TOKEN']) && $_POST['_RESPONSE_TOKEN'] != '') {
          $secretKey  = new Key(MODULE_PAYMENT_ADUMOONLINE_JWT_SECRET_KEY);
          $signer = new Signer();
          $token = (new Parser())->parse((string) $_POST['_RESPONSE_TOKEN']);
          $valid = $token->verify($signer,$secretKey);

          if ( $valid ) {
              //error_log("JWT Token Verified");
              $_SESSION["payment_data"]["JWT_valid"] = 'true';
          }
          else {
              //error_log('JWT Token does not have valid signature!');
              $_SESSION["payment_data"]["JWT_valid"] = 'false';
          }
          //JWT enabled - Check payment status from JWT token
          if($token->getClaim('result') >= 0) {

              $this->notify( 'NOTIFY_PAYMENT_ADUMOONLINE_RETURN_TO_STORE' );

              $_SESSION['cart']->reset( true );
              unset( $_SESSION['sendto'] );
              unset( $_SESSION['billto'] );
              unset( $_SESSION['shipping'] );
              unset( $_SESSION['payment'] );
              unset( $_SESSION['comments'] );
              unset( $_SESSION['cot_gv'] );
              $order_total_modules->clear_posts();
              //zen_redirect( zen_href_link( FILENAME_CHECKOUT_SUCCESS, '', 'SSL' ) );
          } else {
              $messageStack->add_session('checkout_payment', 'Your payment has failed - '.$_POST['_BANK_ERROR_MESSAGE'], 'error');
              zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
          }

      } else {
          //JWT disabled - Check payment status from normal post
          if($_POST['_RESULT'] >= 0) {

              $this->notify( 'NOTIFY_PAYMENT_ADUMOONLINE_RETURN_TO_STORE' );

              $_SESSION['cart']->reset( true );
              unset( $_SESSION['sendto'] );
              unset( $_SESSION['billto'] );
              unset( $_SESSION['shipping'] );
              unset( $_SESSION['payment'] );
              unset( $_SESSION['comments'] );
              unset( $_SESSION['cot_gv'] );
              $order_total_modules->clear_posts();
              //zen_redirect( zen_href_link( FILENAME_CHECKOUT_SUCCESS, '', 'SSL' ) );
          } else {
              $messageStack->add_session('checkout_payment', 'Your payment has failed - '.$_POST['_BANK_ERROR_MESSAGE'], 'error');
              zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
          }
      }

    }

    /**
      * Checks referrer
      *
      * @param string $zf_domain
      * @return boolean
      */
    function check_referrer($zf_domain) {
      return true;
    }

    function after_process() {
      global $insert_id, $order;

      //error_log("Order Total-----------------------------------".print_r($order->info['total'],1));

      $comments = 'AdumoOnline Status: completed - Transaction Index = '.$_SESSION["payment_data"]["_TRANSACTIONINDEX"];
      $orderInsert = zen_update_orders_history($insert_id, $comments, null, 2, 0);

      if($_SESSION["payment_data"]["_AMOUNT"] != $order->info['total']) {
          $comments = 'Amount Validation:  Order amount and gateway amount are different!';
          $orderInsert = zen_update_orders_history($insert_id, $comments, null, 1, 0);
      }

      if($_SESSION["payment_data"]["JWT_valid"] == 'false') {
          $comments = 'JWT Status:  Token does not have valid signature!';
          $orderInsert = zen_update_orders_history($insert_id, $comments, null, 1, 0);
      }

      $_SESSION["payment_data"] = '';
      $_SESSION['order_created'] = '';
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS;

      $error = array('title' => MODULE_PAYMENT_ADUMOONLINE_TEXT_ERROR,
                     'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));

      return $error;
    }

    function check() {
	  global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_ADUMOONLINE_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
	  global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
      values ('Enable AdumoOnline Module', 'MODULE_PAYMENT_ADUMOONLINE_STATUS', 'False', 'Do you want to accept AdumoOnline payments?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");

      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      values ('Merchant ID', 'MODULE_PAYMENT_ADUMOONLINE_MERCHANT_ID', '9ba5008c-08ee-4286-a349-54af91a621b0', 'Your AdumoOnline MerchantID', '6', '1', now())");

	    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      values ('Application ID', 'MODULE_PAYMENT_ADUMOONLINE_APPLICATION_ID', '4196b0b8-db88-42e5-a06d-294a5e4ded87', 'Your AdumoOnline ApplicationID', '6', '2', now())");

	    // $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
      // values ('AdumoOnline Mode', 'MODULE_PAYMENT_ADUMOONLINE_MODE', '1', 'Mode Settings: 0 = Test Mode; 1 = Live Mode', '6', '3', 'zen_cfg_select_option(array(\'0\', \'1\'), ', now())");

      $db->Execute(
          "INSERT INTO ". TABLE_CONFIGURATION ."( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added )
          VALUES( 'Transaction Server', 'MODULE_PAYMENT_ADUMOONLINE_SERVER', 'Test', 'Select the PayFast server to use', '6', '0', 'zen_cfg_select_option(array(\'Live\', \'Test\'), ', now() )" );

      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added)
      values ('Set Order Status', 'MODULE_PAYMENT_ADUMOONLINE_ORDER_STATUS_ID', '1', 'Set the status of orders made with this payment module to this value', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");

      $db->Execute(
          "INSERT INTO " . TABLE_CONFIGURATION . "( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added )
          VALUES( 'Sort Display Order', 'MODULE_PAYMENT_ADUMOONLINE_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())" );

	    // $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      // values ('Redirect Successful URL', 'MODULE_PAYMENT_ADUMOONLINE_SUCCESSFUL_URL', 'https://shoppingcarts.wirecard.co.za/zencart/checkout_return_adumoonline.php', 'The URL to redirect when the transaction is successful', '6', '5', now())");
      //
	    // $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      // values ('Redirect Failed URL', 'MODULE_PAYMENT_ADUMOONLINE_FAILED_URL', 'https://shoppingcarts.wirecard.co.za/zencart/checkout_return_adumoonline.php', 'The URL to redirect when the transaction has failed', '6', '6', now())");

      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      values ('JWT Secret Key', 'MODULE_PAYMENT_ADUMOONLINE_JWT_SECRET_KEY', '4196b0b8-db88-42e5-a06d-294a5e4ded87', 'The JWT secret key, configured in the merchat portal', '6', '6', now())");

      $db->Execute(
          "INSERT INTO " . TABLE_CONFIGURATION . "( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added )
          VALUES( 'Payment Zone', 'MODULE_PAYMENT_ADUMOONLINE_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())" );

    }

    function remove() {
	  global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array(
          'MODULE_PAYMENT_ADUMOONLINE_STATUS',
          //'MODULE_PAYMENT_ADUMOONLINE_MODE',
          'MODULE_PAYMENT_ADUMOONLINE_SERVER',
          'MODULE_PAYMENT_ADUMOONLINE_MERCHANT_ID',
          'MODULE_PAYMENT_ADUMOONLINE_APPLICATION_ID',
          'MODULE_PAYMENT_ADUMOONLINE_CURRENCY',
          // 'MODULE_PAYMENT_ADUMOONLINE_SUCCESSFUL_URL',
          // 'MODULE_PAYMENT_ADUMOONLINE_FAILED_URL',
          'MODULE_PAYMENT_ADUMOONLINE_JWT_SECRET_KEY',
          'MODULE_PAYMENT_ADUMOONLINE_ORDER_STATUS_ID',
          'MODULE_PAYMENT_ADUMOONLINE_SORT_ORDER',
          'MODULE_PAYMENT_ADUMOONLINE_ZONE'
        );
    }

  }
?>
